﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamChartDateTimeX
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();


            MainViewModel vm = new MainViewModel();
            vm.Data = new ObservableCollection<DataItemViewModel>
            {
                new DataItemViewModel { Date = DateTime.Now, Value = 10 },
                new DataItemViewModel { Date = DateTime.Now.Add(new TimeSpan(0,0,5,0)), Value = 20 },
                new DataItemViewModel { Date = DateTime.Now.Add(new TimeSpan(0,0,15,0)), Value = 10 },
                new DataItemViewModel { Date = DateTime.Now.Add(new TimeSpan(0,0,25,0)), Value = 30 },
                new DataItemViewModel { Date = DateTime.Now.Add(new TimeSpan(0,0,30,0)), Value = 24 },
                new DataItemViewModel { Date = DateTime.Now.Add(new TimeSpan(0,0,45,0)), Value = 45 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(1), Value = 10, },
                new DataItemViewModel { Date = DateTime.Now.AddHours(1).Add(new TimeSpan(0,0,30,0)), Value = 30 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2), Value = 40 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,5,0)), Value = 10 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,10,0)), Value = 20 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,15,0)), Value = 10 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,20,0)), Value = 25 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,25,0)), Value = 35 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,30,0)), Value = 20 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,35,0)), Value = 10 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,40,0)), Value = 30 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,45,0)), Value = 50 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(2).Add(new TimeSpan(0,0,50,0)), Value = 45 },
                new DataItemViewModel { Date = DateTime.Now.AddHours(3), Value = 25 },
            };

            DataContext = vm;

        }


    }

    public class MainViewModel : ViewModelBase
    {

        public MainViewModel()
        {

        }

        private ObservableCollection<DataItemViewModel> data;
        public ObservableCollection<DataItemViewModel> Data
        {
            get { return data; }
            set
            {
                data = value;
                OnPropertyChanged("DataItemViewModel");
            }
        }

    }

    public class DataItemViewModel : ViewModelBase
    {
        private DateTime name;
        public DateTime Date
        {
            get { return name; }
            set
            {
                name = value;
                OnPropertyChanged("Date");
            }
        }

        public double DoubleDateTime
        {
            get
            {
                return Date.ToOADate();
            }
        }

        private int value1;
        public int Value
        {
            get { return value1; }
            set
            {
                value1 = value;
                OnPropertyChanged("Value");
            }
        }
    }

    public class ViewModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string name)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }

    public class DateToDoubleConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (parameter != null)
            {
                if (parameter.ToString().Equals("int"))
                {
                    double range = (value as MainViewModel).Data.Max(d => d.DoubleDateTime) - (value as MainViewModel).Data.Min(d => d.DoubleDateTime);
                    TimeSpan dateRange = (value as MainViewModel).Data.Max(d => d.Date) - (value as MainViewModel).Data.Min(d => d.Date);

                    return range / dateRange.TotalHours;

                }

                if (parameter.ToString().Equals("min"))
                    return (value as MainViewModel).Data.Min(d => d.DoubleDateTime);


                if (parameter.ToString().Equals("max"))
                    return (value as MainViewModel).Data.Max(d => d.DoubleDateTime);
            }

            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }

}
